/*  cssed (c) Iago Rubio 2003, 2004 - A tiny CSS editor.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

//#define DEBUG

#include <gtk/gtk.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include "cssedwindow.h"
#include "interface.h"
#include "support.h"
#include "document.h"

/* show an error message - this must change to addere to the HIG             
  http://developer.gnome.org/projects/gup/hig/1.0/windows.html#alert-windows*/
void
cssed_error_message (gchar * message, gchar * title)
{
	GtkWidget* error_box; 
	GtkWidget* label;
	GtkWidget* label_detail;
	
	gchar* error_message;
	
	error_box = create_error_dialog ();	
	gtk_window_set_title ((GtkWindow *) error_box, "");
	
	label = lookup_widget (error_box, "label_msg");
	label_detail = lookup_widget (error_box, "label_detail");
	
	error_message = g_strdup_printf("<span weight=\"bold\" size=\"larger\">%s</span>", title);
	gtk_label_set_text (GTK_LABEL(label), error_message);
	gtk_label_set_use_markup(GTK_LABEL(label),TRUE);
	gtk_label_set_text (GTK_LABEL(label_detail), message);
	gtk_widget_show_all(error_box);
	
	g_free(error_message);
}
/* modal dialogs call with gtk_dialog_run and get the response */
GtkWidget*
create_ok_cancel_dialog (gchar* title, gchar* message)
{
  GtkWidget *ok_cancel_dialog;
  GtkWidget *dialog_vbox;
  GtkWidget *hbox;
  GtkWidget *image;
  GtkWidget *vbox;
  GtkWidget *label_header;
  GtkWidget *label_message;
  GtkWidget *dialog_action_area;
  GtkWidget *cancelbutton;
  GtkWidget *okbutton;
	gchar* markup_title;
	
	markup_title = g_strconcat("<span size='larger'>",title,"</span>",NULL);

  ok_cancel_dialog = gtk_dialog_new ();

  dialog_vbox = GTK_DIALOG (ok_cancel_dialog)->vbox;
  gtk_widget_show (dialog_vbox);

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (dialog_vbox), hbox, TRUE, TRUE, 0);

  image = gtk_image_new_from_stock ("gtk-dialog-question", GTK_ICON_SIZE_DIALOG);
  gtk_widget_show (image);
  gtk_box_pack_start (GTK_BOX (hbox), image, FALSE, FALSE, 20);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox);
  gtk_box_pack_start (GTK_BOX (hbox), vbox, TRUE, TRUE, 0);


  label_header = gtk_label_new (markup_title);
  gtk_widget_show (label_header);
  gtk_box_pack_start (GTK_BOX (vbox), label_header, FALSE, TRUE, 20);
  gtk_label_set_use_markup (GTK_LABEL (label_header), TRUE);
  gtk_label_set_justify (GTK_LABEL (label_header), GTK_JUSTIFY_LEFT);

  label_message = gtk_label_new (message);
  gtk_widget_show (label_message);
  gtk_box_pack_start (GTK_BOX (vbox), label_message, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label_message), TRUE);
  gtk_label_set_justify (GTK_LABEL (label_message), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label_message), TRUE);
  
  dialog_action_area = GTK_DIALOG (ok_cancel_dialog)->action_area;
  gtk_widget_show (dialog_action_area);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area), GTK_BUTTONBOX_END);

  okbutton = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton);
  gtk_dialog_add_action_widget (GTK_DIALOG (ok_cancel_dialog), okbutton, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton, GTK_CAN_DEFAULT);
  
  cancelbutton = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton);
  gtk_dialog_add_action_widget (GTK_DIALOG (ok_cancel_dialog), cancelbutton, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton, GTK_CAN_DEFAULT);

	/* this is unused as I prefer to destroy it in the callback, this will 
	be ever a modal dialog called with gtk_dialog_run and destroyed - as I said 
	- by the caller function
	g_signal_connect_swapped (GTK_OBJECT (ok_cancel_dialog), 
                             "response", 
                             G_CALLBACK (gtk_widget_destroy),
                             GTK_OBJECT (ok_cancel_dialog));*/
							 
  /* Store pointers to all widgets, for use by lookup_widget(). 
  GLADE_HOOKUP_OBJECT_NO_REF (ok_cancel_dialog, ok_cancel_dialog, "ok_cancel_dialog");
  GLADE_HOOKUP_OBJECT_NO_REF (ok_cancel_dialog, dialog_vbox, "dialog_vbox");
  GLADE_HOOKUP_OBJECT (ok_cancel_dialog, hbox, "hbox");
  GLADE_HOOKUP_OBJECT (ok_cancel_dialog, image, "image");
  GLADE_HOOKUP_OBJECT (ok_cancel_dialog, vbox, "vbox");
  GLADE_HOOKUP_OBJECT (ok_cancel_dialog, label_header, "label_header");
  GLADE_HOOKUP_OBJECT (ok_cancel_dialog, label_message, "label_message");
  GLADE_HOOKUP_OBJECT_NO_REF (ok_cancel_dialog, dialog_action_area, "dialog_action_area");
  GLADE_HOOKUP_OBJECT (ok_cancel_dialog, cancelbutton, "cancelbutton");
  GLADE_HOOKUP_OBJECT (ok_cancel_dialog, okbutton, "okbutton");
 */
  gtk_widget_grab_default (okbutton);
  g_free(markup_title);
  return ok_cancel_dialog;
}

GtkWidget*
create_unsaved_files_dialog (void)
{
  GtkWidget *unsaved_files_dialog;
  GtkWidget *dialog_vbox;
  GtkWidget *hbox;
  GtkWidget *image;
  GtkWidget *vbox;
  GtkWidget *label_msg;
  GtkWidget *label_detail;
  GtkWidget *dialog_action_area;
  GtkWidget *button_save_all;
  GtkWidget *button_choose_files;
  GtkWidget *button_dont_save;
  GtkWidget *button_cancel;

  unsaved_files_dialog = gtk_dialog_new ();

  dialog_vbox = GTK_DIALOG (unsaved_files_dialog)->vbox;
  gtk_widget_show (dialog_vbox);

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (dialog_vbox), hbox, TRUE, TRUE, 0);

  image = gtk_image_new_from_stock ("gtk-dialog-warning", GTK_ICON_SIZE_DIALOG);
  gtk_widget_show (image);
  gtk_box_pack_start (GTK_BOX (hbox), image, FALSE, FALSE, 20);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox);
  gtk_box_pack_start (GTK_BOX (hbox), vbox, TRUE, TRUE, 0);

  label_msg = gtk_label_new (_("<span size='larger'>There are documents not saved.  Changes will be lost.</span>"));
  gtk_widget_show (label_msg);
  gtk_box_pack_start (GTK_BOX (vbox), label_msg, FALSE, FALSE, 15);
  gtk_label_set_use_markup (GTK_LABEL (label_msg), TRUE);
  gtk_label_set_justify (GTK_LABEL (label_msg), GTK_JUSTIFY_LEFT);

  label_detail = gtk_label_new (_("<span>If you want to save all unsaved file click the <b>\"Save all\"</b> button, if you want to choose what files to save click in the <b>\"Choose files\"</b> button. If you don't want to save any of them use the <b>\"Don't save\"</b> button. If you don't want to quit the application and save them yourself click the <b>\"Cancel\"</b> button.</span>"));
  gtk_widget_show (label_detail);
  gtk_box_pack_start (GTK_BOX (vbox), label_detail, TRUE, TRUE, 0);
  gtk_label_set_use_markup (GTK_LABEL (label_detail), TRUE);
  gtk_label_set_justify (GTK_LABEL (label_detail), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label_detail), TRUE);

  dialog_action_area = GTK_DIALOG (unsaved_files_dialog)->action_area;
  gtk_widget_show (dialog_action_area);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area), GTK_BUTTONBOX_END);

  button_save_all = gtk_button_new_with_mnemonic (_("_Save all"));
  gtk_widget_show (button_save_all);
  gtk_dialog_add_action_widget (GTK_DIALOG (unsaved_files_dialog), button_save_all, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (button_save_all, GTK_CAN_DEFAULT);

  button_choose_files = gtk_button_new_with_mnemonic (_("_Choose files"));
  gtk_widget_show (button_choose_files);
  gtk_dialog_add_action_widget (GTK_DIALOG (unsaved_files_dialog), button_choose_files, GTK_RESPONSE_ACCEPT);
  GTK_WIDGET_SET_FLAGS (button_choose_files, GTK_CAN_DEFAULT);

  button_dont_save = gtk_button_new_with_mnemonic (_("_Don't save"));
   gtk_widget_show (button_dont_save);
   gtk_dialog_add_action_widget (GTK_DIALOG (unsaved_files_dialog), button_dont_save, GTK_RESPONSE_NO);
   GTK_WIDGET_SET_FLAGS (button_choose_files, GTK_CAN_DEFAULT); 
 
  
  button_cancel = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (button_cancel);
  gtk_dialog_add_action_widget (GTK_DIALOG (unsaved_files_dialog), button_cancel, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (button_cancel, GTK_CAN_DEFAULT);
  
	/*g_signal_connect_swapped (GTK_OBJECT (unsaved_files_dialog), 
                             "response", 
                             G_CALLBACK (gtk_widget_destroy),
                             GTK_OBJECT (unsaved_files_dialog));*/
							 
  /* Store pointers to all widgets, for use by lookup_widget(). 
  GLADE_HOOKUP_OBJECT_NO_REF (unsaved_files_dialog, unsaved_files_dialog, "unsaved_files_dialog");
  GLADE_HOOKUP_OBJECT_NO_REF (unsaved_files_dialog, dialog_vbox, "dialog_vbox");
  GLADE_HOOKUP_OBJECT (unsaved_files_dialog, hbox, "hbox");
  GLADE_HOOKUP_OBJECT (unsaved_files_dialog, image, "image");
  GLADE_HOOKUP_OBJECT (unsaved_files_dialog, vbox, "vbox");
  GLADE_HOOKUP_OBJECT (unsaved_files_dialog, label_msg, "label_msg");
  GLADE_HOOKUP_OBJECT (unsaved_files_dialog, label_detail, "label_detail");
  GLADE_HOOKUP_OBJECT_NO_REF (unsaved_files_dialog, dialog_action_area, "dialog_action_area");
  GLADE_HOOKUP_OBJECT (unsaved_files_dialog, button_save_all, "button_save_all");
  GLADE_HOOKUP_OBJECT (unsaved_files_dialog, button_choose_files, "button_choose_files");
  GLADE_HOOKUP_OBJECT (unsaved_files_dialog, button_cancel, "button_cancel");
	*/
  gtk_widget_grab_default (button_save_all);
  return unsaved_files_dialog;
}

/* Converts a GdkColor to a triplet #RRGGBB string 
   the returned string must be freed by caller  */
gchar*
gdk_color_to_rgb_triplet_string( GdkColor* color)
{
	gchar* rgb;
	float r;
	float g;
	float b;

	r=color->red;
	g=color->green;
	b=color->blue;
	
	r=(r/65535)*255;
	g=(g/65535)*255;
	b=(b/65535)*255;
	
#ifdef DEBUG
	g_print("gdk_color_to_rgb_triplet_string\n\tColor : r(%d) g(%d) b(%d)\n",r,g,b);	
#endif
	
	rgb = g_strdup_printf("#%02x%02x%02x",(int) r,(int) g,(int) b);
	return rgb;
}

/* converts a GdkColor to scintilla rgb integer color */
gint
gdk_color_to_scintilla_integer_color( GdkColor* color )
{
	gdouble r;
	gdouble g;
	gdouble b;
	gint red;
	gint green;
	gint blue;
	gint scicolor;
	
	r=color->red;
	g=color->green;
	b=color->blue;
	
	red =   (r/65535)*255;
	green = (g/65535)*255;
	blue =  (b/65535)*255;	

	scicolor = red | (green << 8) | (blue << 16);
	
#ifdef DEBUG
	g_print("\tscicolor %d %x\n", scicolor, scicolor);	
#endif
	
	return scicolor;
}

/*  I did this for the bluefish project http://bluefish.openoffice.nl 
	It's unused, but I'm sure I will use it */
GtkWidget*
create_custom_button_from_stock(gchar* label_text,gchar *stock_id)
{
  GtkWidget* button;
  GtkWidget* image;
  GtkWidget* box;
  GtkWidget* label;

  button = gtk_button_new();
  box = gtk_hbox_new(FALSE,0);

  image = gtk_image_new_from_stock(stock_id,GTK_ICON_SIZE_BUTTON);
  label = gtk_label_new(label_text);

  gtk_box_pack_start((GtkBox*)box,image,FALSE,FALSE,0);
  gtk_box_pack_end  ((GtkBox*)box,label,FALSE,FALSE,0);
  gtk_widget_show(label);
  gtk_widget_show(image);
  gtk_widget_show(box);
  gtk_container_add(GTK_CONTAINER(button),box);

  return button;
}
/* returned buffer must be freed by caller, input buffer must be allocated
	in memory and it will be disposed */
gchar*
allocated_buffer_add_string(gchar* buffer, const gchar* string)
{
	gchar* newstring;
	newstring = g_strconcat(buffer,string,NULL);
	g_free(buffer);
	return newstring;	
}

void
init_default_config( Tcssed_window *window )
{
	Tcssed_cfg* cfg;
	
	cfg = (Tcssed_cfg*) window->config;
	
	cfg->window_x = 100;
	cfg->window_y = 100;
	cfg->window_width = 400;
	cfg->window_height = 350;
	cfg->notebook_height = 100;
	cfg->sidebar_width = 150;
	cfg->treeview_height = 200;
	cfg->linenumbers = FALSE;
	cfg->autocompletion = FALSE;
	cfg->lineendings = FALSE;
	cfg->whitespaces = FALSE;
	cfg->folding = FALSE;
	cfg->lineswraped = FALSE;
	cfg->opened_docs = NULL;
	cfg->DEFAULT_fore_color = 0x000077;
	cfg->DEFAULT_back_color = 0xffffff;
	cfg->DEFAULT_bold = FALSE;
	cfg->TAG_fore_color = 0xA46621;
	cfg->TAG_back_color = 0xffffff;
	cfg->TAG_bold = TRUE;
	cfg->PSEUDOCLASS_fore_color = 0x990066;
	cfg->PSEUDOCLASS_back_color = 0xffffff;
	cfg->PSEUDOCLASS_bold = FALSE;
	cfg->UNKNOWN_PSEUDOCLASS_fore_color = 0x0000ff;
	cfg->UNKNOWN_PSEUDOCLASS_back_color = 0xffffff;	
	cfg->UNKNOWN_PSEUDOCLASS_bold = FALSE;
	cfg->OPERATOR_fore_color = 0x000099;
	cfg->OPERATOR_back_color = 0xffffff;
	cfg->OPERATOR_bold = FALSE;
	cfg->IDENTIFIER_fore_color = 0x990000; 	
	cfg->IDENTIFIER_back_color = 0xffffff;	
	cfg->IDENTIFIER_bold = TRUE;
	cfg->UNKNOWN_IDENTIFIER_fore_color = 0x0000ff;
	cfg->UNKNOWN_IDENTIFIER_back_color = 0xffffff;
	cfg->UNKNOWN_IDENTIFIER_bold = FALSE;
	cfg->VALUE_fore_color = 0x222222;
	cfg->VALUE_back_color = 0xffffff;	
	cfg->VALUE_bold = FALSE;
	cfg->COMMENT_fore_color = 0x666666;
	cfg->COMMENT_back_color = 0xffffff;
	cfg->COMMENT_bold = FALSE;
	cfg->IMPORTANT_fore_color = 0x000099;
	cfg->IMPORTANT_back_color = 0xffffff;
	cfg->IMPORTANT_bold = TRUE;
	cfg->DIRECTIVE_fore_color = 0x660066;
	cfg->DIRECTIVE_back_color = 0xffffff;
	cfg->DIRECTIVE_bold = FALSE;
	cfg->DOUBLESTRING_fore_color = 0x660033;
	cfg->DOUBLESTRING_back_color = 0xffffff;	
	cfg->DOUBLESTRING_bold = FALSE;
	cfg->SINGLESTRING_fore_color = 0x660033;
	cfg->SINGLESTRING_back_color = 0xffffff;
	cfg->SINGLESTRING_bold = FALSE;
	cfg->CLASS_fore_color = 0x004400;
	cfg->CLASS_back_color = 0xffffff;	
	cfg->CLASS_bold = TRUE;
	cfg->ID_fore_color = 0x004400;
	cfg->ID_back_color = 0xffffff;	
	cfg->ID_bold = TRUE;
	cfg->VALID_VALUE_fore_color = 0x003399;
	cfg->VALID_VALUE_back_color = 0xffffff;
	cfg->VALID_VALUE_bold = FALSE;
	cfg->FUNCTION_fore_color = 0x993300;
	cfg->FUNCTION_back_color = 0xffffff;
	cfg->FUNCTION_bold = FALSE;
	cfg->NUMBER_fore_color = 0x330099;
	cfg->NUMBER_back_color = 0xffffff;
	cfg->NUMBER_bold = FALSE;
	cfg->UNIT_fore_color = 0x990000;
	cfg->UNIT_back_color = 0xffffff;
	cfg->UNIT_bold = FALSE;
	cfg->COLOR_fore_color = 0x006600;
	cfg->COLOR_back_color = 0xffffff;	
	cfg->COLOR_bold = FALSE;
	cfg->HEXACOLOR_fore_color = 0x006600;
	cfg->HEXACOLOR_back_color = 0xffffff;	
	cfg->HEXACOLOR_bold = FALSE;
	cfg->ATTR_MATCH_fore_color = 0x004444;
	cfg->ATTR_MATCH_back_color = 0xffffff;	
	cfg->ATTR_MATCH_bold = FALSE;
	cfg->LANGUAGE_fore_color = 0x990000;
	cfg->LANGUAGE_back_color = 0xffffff;	
	cfg->LANGUAGE_bold = FALSE;	
}

void
save_config_to_file(Tcssed_window* window)
{
	Tcssed_cfg* cfg;
	gchar* home;
	gchar* csseddir;
	gchar* cssedcfg_file;
	gchar* outstr;
	gchar* stylestr;
	gchar* styleout;
	ssize_t written;
	int fd;
	
	cfg = (Tcssed_cfg*) window->config;
	
	home = getenv("HOME");
	if( home == NULL )
		return;
	
	csseddir = g_strconcat( home,"/.cssed",NULL);
	
	//g_print("Config home %s\n", csseddir);

	if( !g_file_test(csseddir,G_FILE_TEST_EXISTS | G_FILE_TEST_IS_DIR) ){
		if( mkdir(csseddir, S_IRWXU) == -1 ){
			//g_print("Can't create dir %s\n", csseddir);
			g_free( csseddir );
			return;
		}
	}	
	cssedcfg_file = g_strconcat( csseddir,"/cssed-cfg.xml",NULL);
	
	if( g_file_test(cssedcfg_file, G_FILE_TEST_IS_REGULAR| G_FILE_TEST_EXISTS) ){
		unlink(cssedcfg_file);
	}
		
	//g_print("Configfile %s\n", cssedcfg_file);
	
	fd = open( cssedcfg_file, O_WRONLY| O_CREAT, S_IRUSR|S_IWUSR );
	if( fd == -1 ){
			//g_print( "Can't open file %s\n", cssedcfg_file );
			g_free( cssedcfg_file );
			g_free( csseddir );
			return;
	}
	outstr = g_strdup_printf(
"<cssed-conf>\n\t  \
	<document>\n\t\t \
		<linenumbers show=\"%s\" />\n\t\t \
		<autocompletion enabled=\"%s\" />\n\t\t \
		<lineendings show=\"%s\" /> \n\t\t \
		<whitespaces show=\"%s\" /> \n\t\t \
		<folding enabled=\"%s\" /> \n\t\t \
		<lineswraped show=\"%s\" />\n\t  \
	</document>\n",
	cfg->linenumbers?"true":"false",
	cfg->autocompletion?"true":"false",
	cfg->lineendings?"true":"false",
	cfg->whitespaces?"true":"false",
	cfg->folding?"true":"false",
	cfg->lineswraped?"true":"false"
	);
	
	written = write( fd, outstr, strlen(outstr) * sizeof(gchar));
	
	//g_print("Config written %d chars\n",written);
	//g_print("\n----------------\n%s\n----------------\n",outstr);
	
	g_free( outstr );
	outstr = NULL;
	
	if( written == -1 ){
		g_print("Can't write to file\n");
		return;
	}
	
	/* **** styles ***** */
	stylestr = g_strdup_printf(
"<style name=\"DEFAULT\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\"	/>\n\t\t \
<style name=\"TAG\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"PSEUDOCLASS\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"UNKNOWN_PSEUDOCLASS\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"OPERATOR\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"IDENTIFIER\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"UNKNOWN_IDENTIFIER\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"VALUE\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"COMMENT\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"IMPORTANT\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"DIRECTIVE\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"DOUBLESTRING\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"SINGLESTRING\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"CLASS\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"ID\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"VALID_VALUE\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"FUNCTION\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"NUMBER\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"UNIT\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"COLOR\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"HEXACOLOR\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"ATTR_MATCH\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t\t \
<style name=\"LANGUAGE\" fore=\"%#06x\" back=\"%#06x\" bold=\"%s\" />\n\t",
		cfg->DEFAULT_fore_color, cfg->DEFAULT_back_color, cfg->DEFAULT_bold?"true":"false",
		cfg->TAG_fore_color, cfg->TAG_back_color, cfg->TAG_bold?"true":"false",
		cfg->PSEUDOCLASS_fore_color, cfg->PSEUDOCLASS_back_color, cfg->PSEUDOCLASS_bold?"true":"false",
		cfg->UNKNOWN_PSEUDOCLASS_fore_color, cfg->UNKNOWN_PSEUDOCLASS_back_color, cfg->UNKNOWN_PSEUDOCLASS_bold?"true":"false",
		cfg->OPERATOR_fore_color, cfg->OPERATOR_back_color, cfg->OPERATOR_bold?"true":"false",
		cfg->IDENTIFIER_fore_color, cfg->IDENTIFIER_back_color, cfg->IDENTIFIER_bold?"true":"false",
		cfg->UNKNOWN_IDENTIFIER_fore_color, cfg->UNKNOWN_IDENTIFIER_back_color, cfg->UNKNOWN_IDENTIFIER_bold?"true":"false",
		cfg->VALUE_fore_color, cfg->VALUE_back_color, cfg->VALUE_bold?"true":"false",
		cfg->COMMENT_fore_color, cfg->COMMENT_back_color, cfg->COMMENT_bold?"true":"false",
		cfg->IMPORTANT_fore_color, cfg->IMPORTANT_back_color, cfg->IMPORTANT_bold?"true":"false",
		cfg->DIRECTIVE_fore_color, cfg->DIRECTIVE_back_color, cfg->DIRECTIVE_bold?"true":"false",	
		cfg->DOUBLESTRING_fore_color, cfg->DOUBLESTRING_back_color, cfg->DOUBLESTRING_bold?"true":"false",	
		cfg->SINGLESTRING_fore_color, cfg->SINGLESTRING_back_color, cfg->SINGLESTRING_bold?"true":"false",	
		cfg->CLASS_fore_color, cfg->CLASS_back_color, cfg->CLASS_bold?"true":"false",	
		cfg->ID_fore_color, cfg->ID_back_color, cfg->ID_bold?"true":"false",
		cfg->VALID_VALUE_fore_color, cfg->VALID_VALUE_back_color, cfg->VALID_VALUE_bold?"true":"false",	
		cfg->FUNCTION_fore_color, cfg->FUNCTION_back_color, cfg->FUNCTION_bold?"true":"false",	
		cfg->NUMBER_fore_color, cfg->NUMBER_back_color, cfg->NUMBER_bold?"true":"false",
		cfg->UNIT_fore_color, cfg->UNIT_back_color, cfg->UNIT_bold?"true":"false",
		cfg->COLOR_fore_color, cfg->COLOR_back_color, cfg->COLOR_bold?"true":"false",
		cfg->HEXACOLOR_fore_color, cfg->HEXACOLOR_back_color, cfg->HEXACOLOR_bold?"true":"false",
		cfg->ATTR_MATCH_fore_color, cfg->ATTR_MATCH_back_color, cfg->ATTR_MATCH_bold?"true":"false",
		cfg->LANGUAGE_fore_color, cfg->LANGUAGE_back_color, cfg->LANGUAGE_bold?"true":"false"
	);
	// "%#06x"
	
	styleout = g_strconcat("\t<highlighting> \n\t\t",stylestr,"</highlighting>\n</cssed-conf>",NULL);
	written = write( fd, styleout, strlen(styleout) * sizeof(gchar));
	
	//g_print("Config written %d chars\n",written);
	//g_print("\n----------------\n%s\n----------------\n",stylestr);
	g_free( styleout );
	g_free( cssedcfg_file );
	g_free( csseddir );
	g_free( stylestr  );
	close( fd );	
}
